package org.openmuc.jdlms.internal.lnassociation;

import org.openmuc.jdlms.internal.APdu;
import org.openmuc.jdlms.internal.AssociateSourceDiagnostic.AcseServiceUser;
import org.openmuc.jdlms.internal.AssociationResult;
import org.openmuc.jdlms.internal.ContextId;
import org.openmuc.jdlms.internal.LnConformanceConverter;
import org.openmuc.jdlms.internal.asn1.cosem.Conformance;
import org.openmuc.jdlms.internal.asn1.iso.acse.Association_information;

/**
 * This exception is thrown, if the initiate request is bad.
 */
class AssociatRequestException extends GenericAssociationException {
    private final AcseServiceUser reason;
    private final Conformance conformanceSetting;

    public AssociatRequestException(AcseServiceUser reason) {
        this.reason = reason;
        this.conformanceSetting = LnConformanceConverter.conformanceFor();
    }

    @Override
    public APdu getErrorMessageApdu() {
        return new InitialResponseBuilder(this.conformanceSetting)
                .setContextId(ContextId.LOGICAL_NAME_REFERENCING_NO_CIPHERING)
                .setResult(AssociationResult.REJECTED_PERMANENT)
                .setAssociateSourceDiagnostic(this.reason)
                .setUserInformation(new Association_information())
                .build();
    }
}
