package org.openmuc.jdlms;

/**
 * This exception signals that a COSEM method has been accessed in a wrong way.
 * 
 * @see CosemMethod
 */
public class IllegalMethodAccessException extends Exception {

    private final MethodResultCode methodResultCode;

    public IllegalMethodAccessException(MethodResultCode methodResultCode) {
        this.methodResultCode = methodResultCode;
    }

    public MethodResultCode getMethodResultCode() {
        return methodResultCode;
    }

}
